/*
* CLIF is a Load Injection Framework
* Copyright (C) 2008 France Telecom
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with this library; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*
* CLIF
*@author Olivier Liu
*
*
*/
package org.ow2.clif.analyze.api.graph.virtualdata;

import java.util.List;
import java.util.Map;

import org.jfree.chart.JFreeChart;
import org.ow2.clif.analyze.lib.graph.ChartData;
import org.ow2.clif.analyze.lib.graph.DatasetOptions;
import org.ow2.clif.analyze.lib.graph.StatisticDataImpl;

public interface RoutineSupplier {
	 //  Fractal interface name 
    /** The Constant Routine supplier. */
    static public final String ROUTINE_SUPPLIER = "Routine Supplier";

    
    /**
     * Save a routine to XML format
     * 
     * @param fileName
     * @param statisticMap
     * @param commentMap
     * @param jFreeChartMap
     * @param imageType
     * @param pageIdAndDatasetIds
     * @param chartDataList
     * @param datasetIdAndGraphOptions
     * @return true if successful
     */
    public boolean saveRoutineToXML(
    		String fileName, 
    		Map<Integer, List<StatisticDataImpl>> statisticMap,
    		Map<String, String> commentMap,
    		Map<Integer, JFreeChart> jFreeChartMap,
    		String imageType,
    		Map<Integer, List<Integer>> pageIdAndDatasetIds,
    		Map<Integer, ChartData> chartDataList,
    		Map<Integer, DatasetOptions> datasetIdAndGraphOptions);
    
}
