/*
 * CLIF is a Load Injection Framework
 * Copyright (C) 2008 France Telecom
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 * Olivier LIU
 *
 * 
 */

package org.ow2.clif.analyze.lib.graph.ui;

import java.awt.Color;
import java.awt.Component;
import java.util.EventObject;

import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

public class CheckBoxCellRenderer extends JCheckBox implements TableCellRenderer { 
	public boolean cellEnabled = true; 
	/** * Constructs a new <code>CheckBoxCellRendrer</code> object. */ 
	public CheckBoxCellRenderer() { 
		super(); this.setEnabled(true); 
	}

	/** * Prepares and Returns the Button Renderer component for the table cell to be renderered this * will set the value and state of the component then paints on table cell * * @param table <code>JTable</code> component where the renderer to be painted * @param value <code>Object</code> value for the renderer * @param isSelected boolean * @param hasFocus boolean * @param row int * @param column int * @return <code>Component</code> */ 
	public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) { 
		if (isSelected){
			Color bgrd = table.getSelectionBackground(); 
			this.setBackground(bgrd);
		}
		else{
			this.setBackground(Color.WHITE);
		}
		if (table.isCellEditable(row, column)) { 
			this.setEnabled(true); 
		}
		else { 
			this.setEnabled(false); 
		} 
		if (value != null && value.equals(new Boolean(true)) || value.toString().equalsIgnoreCase("true") == true) { 
			this.setSelected(true); 
		} 
		else 
		{
			this.setSelected(false); 
		} 
		return this; 
	}

	/** * sets the state of the cell * * @param enabled boolean */

	public void setCellEnabled(boolean enabled) { cellEnabled = enabled; } 



	/** * determines whether this cell is editable or not * * @param anEvent <code>EventObject</code> * @return boolean */ 
	public boolean isCellEditable(EventObject anEvent) { return cellEnabled; } 

	/** * determines whether this cell is editable or not * * @param anEvent <code>EventObject</code> * @return boolean */
	public boolean isCellEnabled(EventObject anEvent) { return cellEnabled; } 
} 
