/*
 * CLIF is a Load Injection Framework Copyright (C) 2006 France Telecom
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2 of the License, or (at your option) any
 * later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 * CLIF
 * 
 * Contact: clif@ow2.org
 */

package org.ow2.isac.plugin.filereader;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;
import java.util.Map;
import org.ow2.clif.scenario.isac.plugin.DataProvider;
import org.ow2.clif.scenario.isac.plugin.SessionObjectAction;
import org.ow2.clif.util.ClifClassLoader;

/**
 * @author Bruno Dillenseger
 */
public class SessionObject implements DataProvider, SessionObjectAction
{
	static final String PLUGIN_FILENAME = "filename";
	String data;

	public SessionObject(Map params)
		throws Exception
	{
		String filename = (String)params.get(PLUGIN_FILENAME);
		InputStream in = ClifClassLoader.getClassLoader().getResourceAsStream(filename);
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		int c;
		while ((c = in.read()) != -1)
		{
			out.write(c);
		}
		data = out.toString();
	}

	private SessionObject(final SessionObject toClone)
	{
		data = toClone.data;
	}


	////////////////////////////
	// DataProvider interface //
	////////////////////////////


	public String doGet(String dummy)
	{
		return data;
	}


	///////////////////////////////////
	// SessionObjectAction interface //
	///////////////////////////////////


	public Object createNewSessionObject()
	{
		return new SessionObject(this);
	}

	
	public void close()
	{
	}

	public void reset()
	{
	}
}
